program wall;

//{$APPTYPE CONSOLE}

uses
  SysUtils,   //
  Dialogs,    //
  Windows,    //
  Classes,  //
  Graphics,  //
  JPEG,        //
  iniFiles,   //
  Registry,   //
  Controls,
  filectrl;

const
{     }
LetInteger: array[0..9]of Char=('0','1','2','3','4','5','6','7','8','9');

//      Integer,  StrToInt
function ToLetInteger(const val: string): Boolean;
var i,x: Byte;
begin
result:=true;
 for i:=1 to Length(val) do
    for x:=0 to High(LetInteger) do
    begin
    if val[i] = LetInteger[x] then Break;
    if x=9 then result:=false;
    end;
end;

function JpgToBmp(B, Jp: string): string;
var BitMap : TBitMap;
    J: TJPEGImage;
begin
BitMap:= TBitmap.Create;
J := TJPEGImage.Create;
J.LoadFromFile(Jp);
BitMap.Assign(J);
BitMap.SaveToFile(B);
BitMap.free;
J.Free;
end;

function StrBmp(s: string): string;
begin
s:=Copy( S, 1, Length(S)-4);
Result:=s+'.bmp';
end;

var
CDini: TiniFile;
qq, dir, s: string;
sr: TSearchRec;
LinkList: TStringList;
AutoRun: boolean;
reg: TRegistry;
i: integer;
begin
if not (FileExists(ParamStr(0)+'.ini')) then
begin
  SelectDirectory('    jpg ',
  'C\',dir);
  if MessageDlg('   ',
  mtInformation,[mbYes, mbNo], 0) = mrYes then
    AutoRun:=true else AutoRun:=false;
end else
begin
//  ini
CDini:=TIniFile.Create(ParamStr(0)+'.ini');
dir:=CDini.ReadString('Wall','FileDir','');
s:=CDini.ReadString('Wall','FileName','');
AutoRun:=CDini.ReadBool('Wall','AutoRun',AutoRun);
CDini.Free;
if not DirectoryExists(dir) then
   Begin
   ShowMessage(dir+'   '+#13
   +' '+ParamStr(0)+'.ini');
   Halt(1);
   end;
//  BMP
LinkList:=TStringList.Create;
if FindFirst(dir+'\*.bmp', faAnyFile, sr)=0 then
begin
DeleteFile(PChar(dir+'\'+sr.Name));
 while FindNext(sr) = 0 do
       DeleteFile(PChar(dir+'\'+sr.Name));
end;
//  jpg
if FindFirst(dir+'\*.jpg', faAnyFile, sr)=0 then
begin
LinkList.Append(dir+'\'+sr.Name);
 while FindNext(sr) = 0 do
       LinkList.Append(dir+'\'+sr.Name);
end;
if LinkList.Count = 0 then
   begin
   ShowMessage('  '+dir+#13+'   *.jpg  ');
   halt;
   end;
//  
if (ParamCount<>0)and(ToLetInteger(ParamStr(1)))and
   (StrToInt(ParamStr(1)) < LinkList.Count) then
  Begin
  qq:=  LinkList.Strings[StrToInt(ParamStr(1))];
  end else
  begin
  Randomize;
  qq:=  LinkList.Strings[Random(LinkList.Count)];
  end;
if ParamStr(1) = 'm' then
  Begin
      for i:=0 to LinkList.Count-1 do
      begin
           if i = LinkList.Count-1 then
           begin
           qq:=  LinkList.Strings[0];
           Break;
           end;                     
           if s = StrBmp(LinkList.Strings[i]) then
           begin
           qq:=  LinkList.Strings[i+1];
           Break;
           end;     
      end;
  end;
JpgToBmp(StrBmp(qq),qq);
qq:=StrBmp(qq);
//  qq   
SystemParametersInfo(SPI_SETDESKWALLPAPER,
0,PChar(qq),SPIF_SENDWININICHANGE);
// 
reg := TRegistry.Create;
reg.RootKey := HKEY_LOCAL_MACHINE;
reg.LazyWrite := false;
reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', false);
if AutoRun then
  reg.WriteString('Wallpaper', ParamStr(0))
 else
  reg.DeleteValue('Wallpaper');
reg.CloseKey;
reg.Free;
end;
CDini:=TIniFile.Create(ParamStr(0)+'.ini');
CDini.WriteBool('Wall','AutoRun',AutoRun);
CDini.WriteString('Wall','FileDir',dir);
CDini.WriteString('Wall','FileName',qq);
CDini.Free;
end.
